"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = __importStar(require("typescript"));
var path_1 = require("path");
var transformer = function (_) {
    return function (context) { return function (rootNode) {
        if (!is(rootNode, ts.SyntaxKind.SourceFile)) {
            return rootNode;
        }
        var compilerOptions = context.getCompilerOptions();
        // TODO should check if baseUrl and paths are defined
        var baseUrl = compilerOptions.baseUrl;
        var paths = compilerOptions.paths;
        var fileDir = path_1.dirname(rootNode.fileName);
        var regPaths = Object.keys(paths).map(function (key) { return ({
            regexp: new RegExp("^" + key.replace("*", "(.*)") + "$"),
            resolve: paths[key][0] // TODO should check if is not empty
        }); });
        function visit(node) {
            if (is(node, ts.SyntaxKind.ImportDeclaration)) {
                if (is(node.moduleSpecifier, ts.SyntaxKind.StringLiteral)) {
                    for (var _i = 0, regPaths_1 = regPaths; _i < regPaths_1.length; _i++) {
                        var path = regPaths_1[_i];
                        var match = node.moduleSpecifier.text.match(path.regexp);
                        if (match) {
                            var out = path.resolve.replace(/\*/g, match[1]);
                            var file = path_1.relative(fileDir, path_1.resolve(baseUrl, out));
                            node.moduleSpecifier.text = file;
                            break;
                        }
                    }
                }
            }
            return ts.visitEachChild(node, visit, context);
        }
        return ts.visitNode(rootNode, visit);
    }; };
};
function is(node, kind) {
    return node.kind === kind;
}
exports.default = transformer;
